'--------------------------   --------------------------------                                                                   
DECLARE  SHOW_SYSTEM_VARIABLES = OFF   '    Proteus    
DECLARE  FSR_CONTEXT_SAVE = OFF   '      FSR
DECLARE  REMINDERS = OFF    '    
DECLARE  WARNINGS = ON   '    
DECLARE  OPTIMISER_LEVEL 0   '                                                                      
;--------------------------  ------------------------------------
DEVICE 16F887
XTAL = 4  '    4 

CONFIG1  DEBUG_OFF, LVP_OFF, FCMEN_OFF, IESO_OFF, BOR_OFF, CPD_OFF, CP_OFF, MCLRE_OFF, PWRTE_OFF, WDT_OFF, INTRC_OSC_NOCLKOUT 
CONFIG2  BOR21V, WRT_OFF

DECLARE PORTB_PULLUPS = OFF  '     PORTB
DECLARE ALL_DIGITAL = ON '        

  
  DIM Sec AS BYTE         
  DIM Mins AS BYTE      
  DIM Hr AS BYTE      
  DIM Day AS BYTE    
  DIM Date AS BYTE       
  DIM Mon AS BYTE       
  DIM Yr AS BYTE      
  DIM Tmp AS BYTE
  DIM Tmp1 AS BYTE
  
ADCON0 = %00000000
ADCON1 = %00000000
ANSEL = %00000000
ANSELH = %00000000
TRISA = %00000000   '  A -  
TRISB = %00000000   '  B -  
TRISC = %00000000   '  C -  
TRISD = %00000000   '  D -  
TRISE = %00000000   '  E -  
CM1CON0 = %00000000
CM2CON0 = %00000000
CM2CON1 = %00000000
SSPCON = %00000000
RCSTA = %00000000
PSTRCON = %00000000                                                                
                                                                
'-------------------------- Display ---------------------------------------------- 
DECLARE  LCD_TYPE ALPHA       '   -  -
DECLARE  LCD_DTPIN  PORTD.0   '   
DECLARE  LCD_ENPIN  PORTC.7   '   E
DECLARE  LCD_RSPIN  PORTC.6   '   RS
DECLARE  LCD_INTERFACE  4     '   
DECLARE  LCD_LINES   2        '   
DECLARE  LCD_COMMANDUS  2000   '    
DECLARE  LCD_DATAUS  50   '      


DECLARE SDA_PIN PORTC.4
DECLARE SCL_PIN PORTC.3

'SSPSTAT = %00000000
'SSPCON = %00101000    
'SSPCON2 = %00000000
'DECLARE HBUS_BITRATE 100 


'--------------------------  ------------------------------------------- 

CLEAR
 
Main:
GOSUB Read_time
CLS
PRINT AT 1, 1, DEC Yr," ",DEC Mon," ",DEC Date, " ", DEC Day
PRINT AT 2, 1, DEC Hr,":",DEC Mins,":",DEC Sec
DELAYMS 200 
GOTO Main


Read_time:                                        '  D
    BUSIN $D0, 0, [Sec,Mins,Hr,Day,Date,Mon,Yr]   '  S
    Tmp = Sec                                     '  1
    GOSUB Fix_bcd_in                              '  3
    Sec = Tmp                                     '  0
    Tmp = Mins                                    '  7
    GOSUB Fix_bcd_in                              '   
    Mins = Tmp                                    '  -
    Tmp = Hr                                      '
    GOSUB Fix_bcd_in                              '  
    Hr = Tmp                                      '  
    Tmp = Date                                    '  
    GOSUB Fix_bcd_in                              '  
    Date = Tmp                                    '  
    Tmp = Mon                                     '  
    GOSUB Fix_bcd_in                              '
    Mon = Tmp                                     '  
    Tmp = Yr                                      '  
    GOSUB Fix_bcd_in                              '  
    Yr = Tmp                                      '  
    Day = Day - 1                                 '  
    RETURN                                        '  
                                                  '  
Write_time:                                       '  .
    Tmp = Mins                                    '  
    GOSUB Fix_bcd_out                             '  
    Mins = Tmp                                    '  
    Tmp = Hr                                      '  
    GOSUB Fix_bcd_out                             '  
    Hr = Tmp                                      '  
    Tmp = Date                                    '  
    GOSUB Fix_bcd_out                             '  
    Date = Tmp                                    '
    Tmp = Mon                                     '  
    GOSUB Fix_bcd_out                             '  
    Mon = Tmp                                     '
    Tmp = Yr                                      '  p
    GOSUB Fix_bcd_out                             '  i
    Yr = Tmp                                      '  c
    Sec = 0                                       '  b
    BUSOUT $D1, 0, [Sec,Mins,Hr,Day,Date,Mon,Yr]  '  a
    RETURN                                        '  s
                                                  '  i
Fix_bcd_in:                                       '  c
    Tmp1 = Tmp & 15                               '  .
    Tmp = Tmp >> 4                                '  r
    Tmp = Tmp1 + 10 * Tmp                         '  u
    RETURN                                        '
                                                  '
Fix_bcd_out:                                      '
    Tmp1 = Tmp / $A                               '
    Tmp = Tmp - (Tmp1 * $A)                       '
    Tmp = Tmp + (Tmp1 << 4)                       '
    RETURN                                        
                                                  
                                                  
                                                  
END                                             
